# Running Tests

This repository includes several scripts and tools to set up, run and debug test scenarios using docker containers.

## Building Container Images

To build the relevant container images, use the Makefile provided in the root directory. To build all images, run:

```sh
make build-images
```

## Running Tests

Simple test scenarios can be set up with the test scripts provided here in the [tests](/tests/) directory. These scripts require a GML file that describes the network topology and the container images:

```sh
python3 tests/test.py tests/minimal.gml
```

For additional features and a Containernet CLI use [tests/test2.py](/tests/test2.py)
This will set up environment variables in the containers for debugging purposes, dump an `idmap.json` file for easier collection and processing of logs from the containers and provide a Containernet CLI:

```sh
python3 tests/test2.py tests/minimal.gml
```

## Collecting and Processing Logs

After running the tests, the logs from all containers can be collected using:

```sh
python3 debug-tools/logs.py
```

This script also replaces all `node_ids` and their representations as IPv6 addresses with the node numbers for better readability.

---

## Further Debugging Options

To attach to any running container for further debugging, use the `docker exec` command. The containers are named `mn.k*`, where `*` is the node number. For example, to get an interactive shell in node 1, run:

```sh
docker exec -it mn.k1 bash
```

#### Environment Variables

When using the [tests/test2.py](/tests/test2.py) script, every container has environment variables set like `$n*` to make it easier to interact with other nodes. For example, use the `ping` command to further debug connectivity issues:

```sh
ping $n1
```

#### Observing Traffic

Traffic generated by using `ping` can conveniently be observed on any given node by using the [tests/dump.sh](/tests/dump.sh) script:

```sh
./dump.sh mn.k2
```

#### Viewing Forwarding Information

To view the forwarding and decapsulation rules installed by the kira daemon, run the following command inside a container:

```sh
nft list ruleset
```

#### Viewing Routing Information

To view the IPv6 routing table, use the `ip -6 route` command inside a container. The output contains all encapsulation routes, routes to underlay neighbors as well as via routes which map installed paths to the correct next hop address and interface.

```sh
ip -6 route
```

To get the route to a specific node, use the `ip route get` command:

```sh
ip route get $n2
```
